
#include "WsimDoc.h"
#include "mmsystem.h"

#define ONE_BLOCK_DATA_NUM		2000
#define BLOCK_NUMS				2
#define FREQUENCY				44100

// WsimView.h : CWsimView NX̃C^[tFCX
//

#pragma once


class CWsimView : public CEditView
{
protected: // VÂݍ쐬܂B
	CWsimView();
	DECLARE_DYNCREATE(CWsimView)

// 
public:
	CWsimDoc* GetDocument() const;

// 
public:

// I[o[Ch
public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);

// 
public:
	virtual ~CWsimView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// ꂽAbZ[W蓖Ċ֐
protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnRun();
protected:
	afx_msg LRESULT OnPlayData(WPARAM wParam, LPARAM lParam);
public:
	HWAVEOUT hWOut;
	WAVEFORMATEX wf;
	short bufOut[BLOCK_NUMS][ONE_BLOCK_DATA_NUM];
	WAVEHDR whOut[BLOCK_NUMS];
	short buf[ONE_BLOCK_DATA_NUM];
	void PreparePlayData(int nBlock);
	afx_msg void OnPlayStop();
	afx_msg void OnGraph();

	CArray < CPoint, CPoint > m_pointArray;
	void draw_line(double x1, double y1, double x2, double y2);
	afx_msg void OnPaint();
protected:
	int wave_on;
public:
	double  x_10;
	double  x_11;
	double  x_12;
	double  x_13;
	double  x_21;
	double  x_22;
	double  x_23;
    double  al;
	double  c0[2048];
	double  c1[2048];

	afx_msg void OnSetup();
	int input_wave;
	double wave_freq;
	afx_msg void OnFreq();
	void fast();
	int freq_mode;
	int draw_text;
};

#ifndef _DEBUG  // WsimView.cpp ̃fobO o[W
inline CWsimDoc* CWsimView::GetDocument() const
   { return reinterpret_cast<CWsimDoc*>(m_pDocument); }
#endif

